<?php
/**
 * @package ats
 * @copyright Copyright (c)2011-2014 Nicholas K. Dionysopoulos / AkeebaBackup.com
 * @license GNU GPL v3 or later
 */

// No direct access
defined('_JEXEC') or die;

class AtsModelInstantreplies extends FOFModel
{
	public function &getItemList($overrideLimits = false, $group = '')
	{
		$overrideLimits = true;
		$group = '';
		
		$results = array();
		
		$search = $this->getState('search', '');
		if(empty($search)) return $results;
		if(strlen($search) < 6) return $results;
		
		$dicats = implode(',',$this->getState('dicats', array()));
		
		$db = $this->getDBO();
		$q = $db->getQuery(true)
			->select(array(
				$db->qn('docimport_article_id').' AS '.$db->qn('id'),
				$db->qn('docimport_category_id').' AS '.$db->qn('catid'),
				$db->qn('title'),
				$db->qn('fulltext'),
			))->from($db->qn('#__docimport_articles'))
			->where($db->qn('docimport_category_id').' IN ('.$dicats.')')
			->where('MATCH('.$db->qn('fulltext').') AGAINST ('.$db->q($search).')')
		;
		$db->setQuery($q, 0, 10);
		$raw_results = $db->loadObjectList();
		
		if(!count($raw_results)) return $results;
		
		foreach($raw_results as $row) {
			$introtext = $row->fulltext;
			
			// Remove the navigation bars
			$mark = strpos($introtext,'</a></td></tr></table><hr /></div>');
			if($mark !== false) $introtext = substr($introtext, $mark + 34);
			$mark = strpos($introtext,'<div class="navfooter"><hr /><table');
			if($mark !== false) $introtext = substr($introtext, 0, $mark);
			// Replace some markup with spaces
			$introtext = str_replace('<li>', ' ', $introtext);
			$introtext = str_replace('<p>', ' ', $introtext);
			$introtext = str_replace('<br/>', ' ', $introtext);
			$introtext = str_replace("\n", ' ', $introtext);
			while(strpos($introtext, '  ') !== false) {
				$introtext = str_replace("  ", ' ', $introtext);
			}
			
			$introtext = substr(strip_tags($introtext),0,150).'&hellip;';
			$url = JRoute::_('index.php?option=com_docimport&view=article&id='.$row->id);
			
			$results[] = (object)array(
				'title'		=> $row->title,
				'preview'	=> $introtext,
				'url'		=> $url
			);
		}
		
		return $results;
	}
}